Package org.optaplanner.core.config.score.trend

## Enum InitializingScoreTrendLevel

- java.lang.Object
- - java.lang.Enum<InitializingScoreTrendLevel>
  - - org.optaplanner.core.config.score.trend.InitializingScoreTrendLevel

- All Implemented Interfaces:
    `Serializable`, `Comparable<InitializingScoreTrendLevel>`

      public enum InitializingScoreTrendLevel
      extends Enum<InitializingScoreTrendLevel>

  Bounds 1 score level of the possible `Score`s for a `PlanningSolution` as more and more variables are initialized (while the already initialized variables don't change).
  See Also:
    `InitializingScoreTrend`

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `ANY` | No predictions can be made.
    `ONLY_DOWN` | During initialization, the `Score` is monotonically decreasing.
    `ONLY_UP` | During initialization, the `Score` is monotonically increasing.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static InitializingScoreTrendLevel` | `valueOf​(String name)` | Returns the enum constant of this type with the specified name.
    `static InitializingScoreTrendLevel[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### ANY

          public static final InitializingScoreTrendLevel ANY

      No predictions can be made.

    - #### ONLY_UP

          public static final InitializingScoreTrendLevel ONLY_UP

      During initialization, the `Score` is monotonically increasing. This means: given a non-fully initialized `PlanningSolution` with a `Score` A, initializing 1 or more variables (without altering the already initialized variables) will give a `PlanningSolution` for which the `Score` is better or equal to A.

      In practice, this means that the score constraints of this score level are all positive, and initializing a variable cannot unmatch an already matched positive constraint.

      Also implies the perfect minimum score is 0.

    - #### ONLY_DOWN

          public static final InitializingScoreTrendLevel ONLY_DOWN

      During initialization, the `Score` is monotonically decreasing. This means: given a non-fully initialized `PlanningSolution` with a `Score` A, initializing 1 or more variables (without altering the already initialized variables) will give a `PlanningSolution` for which the `Score` is worse or equal to A.

      In practice, this means that the score constraints of this score level are all negative, and initializing a variable cannot unmatch an already matched negative constraint.

      Also implies the perfect maximum score is 0.

  - ### Method Detail

    - #### values

          public static InitializingScoreTrendLevel[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (InitializingScoreTrendLevel c : InitializingScoreTrendLevel.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static InitializingScoreTrendLevel valueOf​(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null